﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Infragistics.Web.UI.GridControls;
using System.Data;

namespace WebApplication1
{
    public partial class _Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                LoadData();
            }
            else
            {
                DataSet ds = ViewState["DataSet"] as DataSet;
                AuditDataWebGrid.DataSource = ds;
                AuditDataWebGrid.DataBind();
            }
        }

        private void LoadData()
        {
            DataSet ds = new DataSet();

            DataTable table = new DataTable();
            table.TableName = "Customers";

            // Create two columns, ID and Name.
            DataColumn idColumn = table.Columns.Add("ID", typeof(int));
            table.Columns.Add("Name", typeof(string));
            table.Columns.Add("IS_SELECTED", typeof(int));
            table.Columns.Add("STATUS", typeof(string));

            // Set the ID column as the primary key column.
            table.PrimaryKey = new DataColumn[] { idColumn };

            for (int i = 0; i < 30; i++)
            {
                table.Rows.Add(new object[] { i, "Customer "+ i,0,0 });
            }
            table.AcceptChanges();
            ds.Tables.Add(table);

            PopulateGrid(ds);
        }

        protected void UpdateButton_OnClick(object sender, EventArgs e)
        {
        }

        protected void StatusFilterDropDownList_OnSelectedIndexChanged(object sender, EventArgs e)
        {
            //((IDataGridPresenter)PresenterController).GetData();
        }

        protected void MultiSelectCheckBox_OnCheckedChanged(object sender, EventArgs e)
        {
            SetRowsState(((CheckBox)sender).Checked);
        }

        private void SetRowsState(bool isChecked)
        {
            DataSet ds = ViewState["DataSet"] as DataSet;

            foreach (DataRow row in ds.Tables[0].Rows)
            {
                row["IS_SELECTED"] = (isChecked) ? 1 : 0;
            }
            ds.AcceptChanges();
            PopulateGrid(ds);
        }

        private void PopulateGrid(DataSet ds)
        {
            AuditDataWebGrid.DataSource = ds;
            AuditDataWebGrid.DataBind();
            ViewState.Add("DataSet", ds);
        }

        protected void IsSelectedCheckBox_OnCheckedChanged(object sender, EventArgs e)
        {
            UpdateRowState(int.Parse(((CheckBox)sender).Text), ((CheckBox)sender).Checked);
        }

        private void UpdateRowState(int id, bool isChecked)
        {
            DataSet dataSet = ViewState["DataSet"] as DataSet;

            if (dataSet != null)
            {
                DataRow[] rows = dataSet.Tables[0].Select("ID=" + id);

                foreach (DataRow row in rows)
                {
                    row["IS_SELECTED"] = (isChecked ? "1" : "0");
                }
                dataSet.AcceptChanges();
                PopulateGrid(dataSet);
            }
        }

        protected void AuditDataWebGrid_ColumnSorted(object sender, SortingEventArgs e)
        {
            //((IDataGridPresenter)PresenterController).Sort(e);
        }

        protected void AuditDataWebGrid_DataFiltering(object sender, FilteringEventArgs e)
        {
            //((IDataGridPresenter)PresenterController).Filter(e);
            e.Cancel = true;
        }

        protected void AuditDataWebGrid_ColumnMoved(object sender, ColumnMovingEventArgs e)
        {
            //((IDataGridPresenter)PresenterController).ColumnMoving(e);
        }

        protected void AuditDataWebGrid_InitializeRow(object sender, RowEventArgs e)
        {
            //((IAuditTablePresenter)PresenterController).FormatRow(e);
        }
    }
}
